<?php

require_once 'classes/connexio/connexio.php';

class auth extends connexio{

    private $usuari;
    private $password;

    public function login($postBody){

        $dadesForm=json_decode($postBody,true);
        

        if(!isset($dadesForm['usuari'])|| !isset($dadesForm['password'])){
           

            $error=array("missatge"=>"No existeixen els camps", "status"=>"0");
                return $error;
    
        }else{

            $this->usuari=filter_var($dadesForm['usuari'],FILTER_SANITIZE_EMAIL);
            $this->password=filter_var($dadesForm['password'],FILTER_SANITIZE_SPECIAL_CHARS);

           
            $dades=$this->getDadesUsuari($this->usuari);
            if($dades){

                $userId=$dades[0]['userId'];
                $contraBase=$dades[0]['contra'];
                $contraUsuari=$this->password;

                if(password_verify($contraUsuari,$contraBase)){

                    $genToken=$this->crearToken($userId);
                    

                    if($genToken){

                        //Envia el token al client.
                        $resToken=array("token"=>"$genToken","missatge"=>"Usuari correcte", "userId"=>"$userId", "status"=>"1");
                        return $resToken;  
                        //Token

                    }else{

                        $error=array("missatge"=>"Error token", "status"=>"0");
                        return $error;

                    }
                     

                }else{
                    $error=array("missatge"=>"Dades incorrectes", "status"=>"0");
                     
                    return $error;

                }
                
               

            }else{

                $error=array("missatge"=>"L'usuari $this->usuari no existeix", "status"=>"0");
                return $error;

            }
    
    
        }
        
       
    }

    private function getDadesUsuari($correu){

        $query= "SELECT userId, contra FROM usuaris WHERE correu='". $correu ."'"; 
        //print_r($query);
        $dades=parent::getDades($query);
        if(isset($dades[0]['userId'])){

            return $dades;

        }else{

            return 0;


        }

    }

    //Funció que crea el token d'identificació.

    private function crearToken($userId){


        //Genera el token.
        $auxToken=true;
        $token=bin2hex(openssl_random_pseudo_bytes(16,$auxToken));
        //print_r($token);

        //Guarda el token a la base de dades.
        
        $data=date("Y-m-d H:i");
        $query="REPLACE INTO tokens (userId,token,data) VALUES ('$userId','$token','$data')";
        //print_r($query);
        $verificar= parent::setDades($query);
        if($verificar>0){
            
            return $token;

        }else{

            return 0;
        }



    }


}

?>