<?php


require_once "classes/connexio/connexio.php";
 
 

class temporal extends connexio{

     private $codi;
     private $userId;
     private $descripcio;
     private $pes;
     private $valor; 
     private $material;
     private $quantitat;
     private $sumaPes;
     private $sumaValor;
     private $sumaQuantitat;


     /////////////////////////////////////////GET////////////////////////////////////////////////////////////

      //Funció que llista tots els productes de la taula temporal
      public function productesTemp($userId){
        $query="SELECT * FROM temporal WHERE userId= $userId";
        $dades=(parent::getDades($query));

        if($dades){
           return $dades;
           
        }else{

          $error=array("missatge"=>"No existeixen dades", "status"=>"1", "valor"=>"0");
               return  $error;   


        }
       
      }

    //////////////////////////////////// POST//////////////////////////////////////////////////

    public function temporalProductes($postBody){
       //print_r($postBody);
      
      $dadesForm=json_decode($postBody,true);
     
      //Comprova si existeixen els valors.
      if(!isset($dadesForm['codi']) || !isset($dadesForm['userId'])|| !isset($dadesForm['descripcio']) || !isset($dadesForm['pes'])||
      !isset($dadesForm['valor']) || !isset($dadesForm['material'])|| !isset($dadesForm['quantitat'])){

        $error=array("missatge"=>"Valors inexistents", "status"=>"0");
            return $error;
      }else{

        $this->codi=filter_var($dadesForm['codi'],FILTER_SANITIZE_SPECIAL_CHARS);
        $this->userId=filter_var($dadesForm['userId'],FILTER_SANITIZE_SPECIAL_CHARS);
        $this->descripcio=filter_var($dadesForm['descripcio'],FILTER_SANITIZE_SPECIAL_CHARS);
        $this->pes=filter_var($dadesForm['pes'],FILTER_SANITIZE_SPECIAL_CHARS);
        $this->valor=filter_var($dadesForm['valor'],FILTER_SANITIZE_SPECIAL_CHARS);
        $this->material=filter_var($dadesForm['material'],FILTER_SANITIZE_SPECIAL_CHARS);
        $this->quantitat=filter_var($dadesForm['quantitat'],FILTER_SANITIZE_SPECIAL_CHARS);


        //Comprova si existeix el producte a la base de dades.
        $llista=$this->llistarProductes();

        //Si existeix l'actualitza amb les noves dades.
        if($llista){

          $dades=$this->modProductes();
          return $dades;
          

        //Si no existeix insereix el nou producte.
        }else{

          $dades=$this->insertProductes();

          return $dades;
         

        }
        
      }
  
    }


      //Funció que comprova si el codi existeix a la taula temporal.
      public function llistarProductes(){

        $query1= "SELECT codi,pes,valor,quantitat FROM temporal WHERE codi='" . $this->codi ."' AND userId='" . $this->userId ."'";
        $dades=(parent::getDades($query1));

        if($dades){
         
          

        //Suma la quantitat i la multiplica pel pes i el valor en el cas que repetim el producte.
        //D'aquesta manera aconseguim el pes i el valor total acumulat a l'operació.
        $this->sumaQuantitat=$dades[0]['quantitat']+ floatval($this->quantitat);
        $this->sumaPes=$dades[0]['pes']+($this->pes*floatval($this->quantitat));
        $this->sumaValor=$dades[0]['valor']+($this->valor*floatval($this->pes))*floatval($this->quantitat);

        return $dades;
        }else

        $this->sumaPes=$this->pes*floatval($this->quantitat);
        $this->sumaValor=$this->valor*floatval($this->pes)*floatval($this->quantitat);
        return($dades);
      }
    
      //Funció que actualitza les dades en el cas que el producte existeixi en la taula temporal.
      //D'aquesta manera no es repeteixen els productes.
      public function modProductes(){

               
        $query= "UPDATE temporal SET codi='". $this->codi ."',descripcio='". $this->descripcio ."',pes=". $this->sumaPes . 
        ',valor=' . $this->sumaValor . ",material='". $this->material ."',quantitat='". $this->sumaQuantitat .
        "' WHERE codi='" . $this->codi ."' AND userId='" . $this->userId ."'";
                
          $insertDades=(parent::setDades($query));

           if($insertDades >0){

            $status=array("missatge"=>"Productes guardats correctament", "status"=>"1");
             return $status;
            
        }else{
            
              $error=array("missatge"=>"Error en guardar productes", "status"=>"0");
               return  $error;    
        }
                    

      }

        //Funció que insereix nous productes a la taula temporal.
        public function insertProductes(){

               
        $query= "INSERT INTO temporal (codi,userId,descripcio,pes,valor,material,quantitat)VALUES
        ('". $this->codi ."','". $this->userId ."','". $this->descripcio ."',". $this->sumaPes . 
        ',' . $this->sumaValor . ",'". $this->material ."','". $this->quantitat ."')";
        //print_r($query);
                
          $insertDades=(parent::setDades($query));

          if($insertDades>0){

             $status=array("missatge"=>"Productes guardats correctament", "status"=>"1");
             return $status;
            
        }else{
            
            $error=array("missatge"=>"Error en guardar productes", "status"=>"0");
            return  $error;       
         }
                    

      }

      ///////////////////////////////////////////////DELETE//////////////////////////////////////////////

      function deleteProductes($postBody){

        $dades=json_decode($postBody,true);
        
       

        if(!isset($dades['codi']) || !isset($dades['userId']) ){

          $error=array("missatge"=>"Error en eliminar productes", "status"=>"0");
          return  $dades; 

        }else{

          $codi=$dades['codi'];
          $userId=$dades['userId'];
          $query= "DELETE FROM temporal WHERE codi= $codi AND userId= $userId" ; 
          $deleteDades=parent::setDades($query);
          //print_r($deleteDades);

          };
          

          if($deleteDades >0){

            $status=array("missatge"=>"Productes eliminats correctament", "status"=>"1");
             return $status;

          }else{

            $error=array("missatge"=>"Error en eliminar productes", "status"=>"0");
            return  $error;   

          }
          
        }

        


      }
                

              
              
               
            
              
         
             
       


        

    








?>