<?php 

require_once "classes/connexio/connexio.php";
 
 

class validarQR extends connexio{

     private $userId;
     private $QR;
     private $material;
     

    /////////GUARDA ELS NÚMEROS D'IDENTIFICACIÓ DELS CODIS QR GENERATS A L'APLICACIÓ////////////////

    //Funció que rep les dades i retorna les dades de la taula validarqr.

    public function dadesQR($postBody){
        $dadesForm=json_decode($postBody,true);
     
        //Comprova si existeixen els valors.
        if(!isset($dadesForm['qr']) || !isset($dadesForm['userId'])|| !isset($dadesForm['material'])){
  
          $error=array("missatge"=>"Valors inexistents", "status"=>"0");
              return $error;
        }else{
  
          $this->QR=filter_var($dadesForm['qr'],FILTER_SANITIZE_SPECIAL_CHARS);
          $this->userId=filter_var($dadesForm['userId'],FILTER_SANITIZE_SPECIAL_CHARS);
          $this->material=filter_var($dadesForm['material'],FILTER_SANITIZE_SPECIAL_CHARS);
         
  
  
          //Comprova si existeix el codi a la base de dades.
          $llista=$this->llistarCodis();
  
          //Si existeix l'actualitza amb les noves dades.
          if($llista){
  
            $dades=$this->modCodis();
            return $dades;
            
  
          //Si no existeix insereix el nou codi.
          }else{
  
            $dades=$this->insertCodis();
  
            return $dades;
           
  
          }
          
        }

        
  
    }

    /*///////////////////VALIDA ELS CODIS QR GENERATS A L'APLICACIÓ, GUARDA ELS PRODUCTES A LA TAULA DEFINITIVA I ELIMINA ELS DE LA
    ///////////////////////////////////////////// TAULA TEMPORAL. ////////////////////////////////////////////////////////////////////
    */

    //Funció que comprova si el codi existeix a la taula validarqr per fer la comprovació des d'Arduino.//
    public function validarArduino($userId,$codiQr,$material){

      
      //Valida l'existència de l'usuari i del codi dins la taula validarqr.

      $query= "SELECT codiQR FROM validarqr WHERE  userId= '" . $userId."' AND  codiQR= '" . $codiQr. "' AND  material= '" . $material."'";  
      $dades=(parent::getDades($query));
      //print_r($query);
    
      if($dades){
      //Si existeix el codi.
      //Comprova l'existència de dades de l'usuari dins la taula definitiva.

      $query1="SELECT * FROM definitiva WHERE userId= '" . $userId. "' AND  material= '" . $material."'";
      $dades1=(parent::getDades($query1));
      //print_r($query1);
      //print_r($dades1);

      //Si existeixen dades envia aquestes de la taula definitiva a la temporal.

      if($dades1){

      $query2= "INSERT INTO temporal (codi,userId,descripcio,pes,valor,material,quantitat ) SELECT
      codi,userId,descripcio,pes,valor,material,quantitat FROM definitiva WHERE userId= '" . $userId."' AND  material= '" . $material."'group by codi";
      $dades2=(parent::setDades($query2));
      //print_r($query2);
      //print_r($dades2);


        //Un cop guardades, suma i agrupa els camps dins la taula temporal i els torna a enviar a la taula definitiva.
      if($dades2>0){

        $dades3=$this->insertDefinitiva($userId,$material);

         //Un cop guardades les dades a la taula definitiva elimina els productes de la taula temporal.

        if($dades3>0){

          $dades4=$this->deleteTemporal($userId,$material);

           //Un cop eliminades les dades a la taula temporal elimina el codi QR de la taula validaqr.

          if($dades4){

            $dades5=$this->deleteCodis($userId,$material);

            if($dades5){

               return $dades;
            }

           
          }

        }
        
      }

      //Si no existeixen dades a la taula definitiva guarda les dades de la taula temporal dins la taula definitiva.

      }else{

        

        $dades6=$this->insertDefinitiva($userId, $material);

        //Un cop guardades les dades a la taula definitiva elimina els productes de la taula temporal.

        if($dades6>0){

          $dades7=$this->deleteTemporal($userId, $material);

          //Un cop eliminades les dades a la taula temporal elimina el codi QR de la taula validaqr.

          if($dades7){

            $dades8=$this->deleteCodis($userId, $material);

            if($dades8){

              return $dades;
            }

            
          }

         }
      

      }

    
  }

  }

  /////////////////////////////////// FUNCIONS TAULES TEMPORAL I DEFINITIVA /////////////////////////////////////////////////////////////
    

    //Funció que guarda els productes dins la taula definitiva després de sumar i agrupar els valors de la taula temporal.

    private function insertDefinitiva($userId, $material){

      $query= "REPLACE INTO definitiva (codi,userId,descripcio,pes,valor,material,quantitat ) SELECT codi, userId, descripcio,
      SUM(pes) as pes,SUM(valor) as valor, material, SUM(quantitat) as quantitat FROM temporal 
      WHERE userId='" .$userId."' AND  material= '" . $material. "' group by codi ";
     //print_r($query);
     $dades=(parent::setDades($query));

     return $dades;
     //print_r($dades);


    }

    //Funció que elimina els productes de la taula temporal un cop guardats en la taula definitiva.

    private function deleteTemporal($userId, $material){

      $query= "DELETE FROM temporal WHERE userId='".$userId."' AND  material= '" . $material."'";
      $dades=(parent::setDades($query));
      //print_r($query);
      //print_r($dades);
      return $dades;

    }


    ///////////////////////////////////////////FUNCIONS TAULA VALIDAQR /////////////////////////////////////////////////////////////

    //Funció que comprova si el codi existeix a la taula validarqr.
    private function llistarCodis(){

        $query1= "SELECT userId, codiQR FROM validarqr WHERE userId='" . $this->userId ."' AND  material= '" . $this->material."'";
        $dades=(parent::getDades($query1));
        //print_r($query1);

        if($dades){

        return $dades;

        }
      }
    
      //Funció que actualitza les dades en el cas que el codi existeixi a la taula validaqr.
     
      private function modCodis(){

               
        $query= "UPDATE validarqr SET codiQR='". $this->QR .
        "' WHERE userId='" . $this->userId . "' AND  material= '" . $this->material."'";

        //print_r($query);
                
          $insertDades=(parent::setDades($query));

           if($insertDades >0){

            $status=array("missatge"=>"Codi guardat correctament", "status"=>"1");
             return $status;
            
        }else{
            
              $error=array("missatge"=>"Codi existent", "status"=>"0");
               return  $error;    
        }
                    

      }

        //Funció que insereix el nou codi a la taula validaqr.
        private function insertCodis(){

               
        $query= "INSERT INTO validarqr (userId,codiQR,material )VALUES
        ('". $this->userId ."','". $this->QR ."','". $this->material ."')";
        //print_r($query);
                
          $insertDades=(parent::setDades($query));

          if($insertDades>0){

             $status=array("missatge"=>"Codi guardat correctament", "status"=>"1");
             return $status;
            
        }else{
            
            $error=array("missatge"=>"Codi existent", "status"=>"0");
            return  $error;       
         }
                    

      }


      //Funció que elimina les dades de la taula validaqr un cop s'han guardat els productes a la taula definitiva.
      private function deleteCodis($userId, $material){

        $query= "DELETE FROM validarqr WHERE userId='".$userId. "' AND  material= '" . $material."'";
        $dades=(parent::setDades($query));
        //print_r($query);
        //print_r($dades);
        return $dades;

      }



}


?>