<?php

header("Access-Control-Allow-Origin: *");
header('Access-Control-Allow-Methods: PUT, GET, POST, DELETE, OPTIONS');
header("Access-Control-Allow-Headers: Origin, X-Requested-With, Content-Type, Accept, Authorization");
header('content-type: application/json; charset=utf-8');

require_once 'classes/genericsClass.php';
require_once 'classes/verificaAcces.php';




$productes = new prodGenerics;
$verificaToken= new verifica;







///////////////////////////////MÈTODE GET//////////////////////////////////////////////////

//Mètode que busca si el codi existeix a la taula generics i retorna les dades.

if($_SERVER['REQUEST_METHOD']=='GET'){

   
    $dadesForm=$_GET['codi'];
    //Verifica que el token enviat existeix en la base de dades.

    
    
    $authToken=$_GET['token'];
    $userId=$_GET['userId'];
    
    $resVerificaToken=$verificaToken->acces($authToken, $userId);

    //Si el token és correcte, busca el codi a la base de dades.
    if($resVerificaToken){

        $resultatProducte = $productes->buscarCodi($dadesForm);
        echo json_encode($resultatProducte);
       


    }else{

        //Retorna missatge d'error.

        $error=array("missatge"=>"Identificació incorrecta", "status"=>"0");
        echo json_encode($error);


    }

    ///////////////////////////////MÈTODE POST//////////////////////////////////////////////////

    /*Mètode que busca dins de la taula generics el codi i la descripció filtrats pel material 
    i retorna les dades.*/
    
    }else if($_SERVER['REQUEST_METHOD']=='POST'){  

    $postBody=file_get_contents("php://input");
    $dadesForm=json_decode($postBody,true);

    
    //Verifica que el token enviat existeix en la base de dades.
    
    $authToken=$dadesForm['token'];
    $userId=$dadesForm['userId'];
    
    $resVerificaToken=$verificaToken->acces($authToken, $userId);

    //Si el token és correcte, busca el codi a la base de dades.
    if($resVerificaToken){

        $dades = $productes->llistaSenseCodi($postBody);
        echo json_encode($dades,JSON_UNESCAPED_UNICODE); 
       


    }else{

        //Retorna missatge d'error.

        $error=array("missatge"=>"Identificació incorrecta", "status"=>"0");
        echo json_encode($error);


    }







 

}else{  

        //Retorna missatge d'error.

        $error=array("missatge"=>"El mètode utilitzat no és correcte", "status"=>"0");
        echo json_encode($error,JSON_UNESCAPED_UNICODE);  

}
    



?>