//Importem les llibreries.
#include <LiquidCrystal.h>
#include <SPI.h>
#include <Ethernet.h>




//Assignem les connexions per la pantalla LCD.
LiquidCrystal lcd(9,8,5,4,3,2);

//Assignem l'adreça mac per la placa ethernet.
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };

//Assignem una adreça IP.
IPAddress ip(192, 168, 1, 62);


//Creem una variable del tipus EthernetClient.
EthernetClient client;

//Definim l'adreça IP on es troba el servidor.
//IPAddress server(192,168,1,60);  
char server[] = "Nom de domini"; 
IPAddress myDns(8, 8, 4, 4); 

//Variable per emmagatzemar la resposta del servidor.
String resposta="";

//Assigna pin al led.
const int led1=7;

void setup() {

  //Inicialitza la pantalla LCD.
  lcd.begin(16,2);

  //Defineix el tipus de pin del led.
  pinMode(led1,OUTPUT);
  
  //Inicialitza la comunicació del port serial.
    Serial.begin(9600);

    delay(1000);

  //Inicialitza la connexió de xarxa.
    Ethernet.begin(mac, ip, myDns);
  

    lcd.setCursor(0,0);
    lcd.print("Connectant...");
  
   
    Serial.print("IP ");
    Serial.println(Ethernet.localIP());
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("   Connectat");
    
  
  }
  

void loop() {
  
  //Condició que llegeix les dades del port serial i les envia a la funció connexio.
    if(Serial.available()>0){

      String dades=Serial.readString();
      //Serial.print(dades);
      int carFinal=dades.length()-1;
      //Elimina caràcter buit al final del String.
      dades.remove(carFinal,1);
      //Serial.print(dades.length());
      //Serial.print(dades);

      //Crida a la funció connexio i li passa les dades del String.
      connexio(dades);

        
          
    }   

}

  //Funció que connecta amb el servidor i retorna les dades per l'obertura de la porta.

  void connexio(String dadesQr){


  //Condició que connecta amb l'API i li passa les dades.  
  if (client.connect(server, 80)) {
    Serial.print("Connectat a ");
    Serial.println(client.remoteIP());
    // Make a HTTP request:
    client.print("GET http://nom de domini");
    client.print(dadesQr);
    client.println();

  //Retorna un error en el cas que no es connecti amb l'API.  
  } else {
   
    Serial.println("Error connexió servidor");
       lcd.clear();
       lcd.setCursor(0,0);
       lcd.print(" Error connexio");
       lcd.setCursor(0,1);
       lcd.print("    servidor");
       client.stop();
       delay(5000);

       //Reinicia el sistema.
       setup();
  }

  delay(500);

  
  //Bucle que llegeix la resposta de l'API i l'emmagatzema a la variable resposta.
  while(client.available()){
    char c = client.read();
    resposta +=c;
    Serial.println(resposta);
    

   //Condició que encén el led i obre la porta en el cas que la resposta de l'API sigui afirmativa.
    if(resposta=="1"){

       Serial.println("Porta oberta");
       lcd.clear();
       lcd.setCursor(0,0);
       lcd.print("  Porta oberta");
       resposta="";
       client.stop(); 
       digitalWrite(led1,HIGH);
       delay(2000);
       digitalWrite(led1, LOW);
       delay(3000);

        //Reinicia el sistema.
       setup();
       
   //Retorna un error en el cas que la resposta de l'API no sigui afirmativa.       
    }else{

      Serial.println("Error de lectura");
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("Error de lectura");
      resposta="";
      client.stop();
      delay(5000);

       //Reinicia el sistema.
      setup();
      
    }

    } 

   }  
    
   
  

  




  
