import { NgModule } from '@angular/core';
import { PreloadAllModules, RouterModule, Routes } from '@angular/router';

const routes: Routes = [
  {
    path: '',
    redirectTo: 'inici',
    pathMatch: 'full',
  },

  {
    path: 'inici',
    loadChildren: () =>
      import('./pages/inici/inici.module').then((m) => m.IniciPageModule),
  },
  {
    path: 'activitat',
    loadChildren: () =>
      import('./pages/activitat/activitat.module').then(
        (m) => m.ActivitatPageModule
      ),
  },
  {
    path: 'bar-code',
    loadChildren: () =>
      import('./pages/bar-code/bar-code.module').then(
        (m) => m.BarCodePageModule
      ),
  },
  {
    path: 'bonificacions',
    loadChildren: () =>
      import('./pages/bonificacions/bonificacions.module').then(
        (m) => m.BonificacionsPageModule
      ),
  },
  {
    path: 'contacte',
    loadChildren: () =>
      import('./pages/contacte/contacte.module').then(
        (m) => m.ContactePageModule
      ),
  },
  {
    path: 'dades',
    loadChildren: () =>
      import('./pages/dades/dades.module').then((m) => m.DadesPageModule),
  },
  {
    path: 'funcionament',
    loadChildren: () =>
      import('./pages/funcionament/funcionament.module').then(
        (m) => m.FuncionamentPageModule
      ),
  },
  {
    path: 'notificacions',
    loadChildren: () =>
      import('./pages/notificacions/notificacions.module').then(
        (m) => m.NotificacionsPageModule
      ),
  },
  {
    path: 'recicla',
    loadChildren: () =>
      import('./pages/recicla/recicla.module').then((m) => m.ReciclaPageModule),
  },
  {
    path: 'productes-temp',
    loadChildren: () =>
      import('./pages/productes-temp/productes-temp.module').then(
        (m) => m.ProductesTempPageModule
      ),
  },
  {
    path: 'qr-code',
    loadChildren: () =>
      import('./pages/qr-code/qr-code.module').then((m) => m.QrCodePageModule),
  },
  {
    path: 'registre',
    loadChildren: () =>
      import('./pages/registre/registre.module').then(
        (m) => m.RegistrePageModule
      ),
  },
  {
    path: 'sessio',
    loadChildren: () =>
      import('./pages/sessio/sessio.module').then((m) => m.SessioPageModule),
  },
  {
    path: 'no-codi',
    loadChildren: () =>
      import('./pages/no-codi/no-codi.module').then((m) => m.NoCodiPageModule),
  },
  {
    path: 'manual',
    loadChildren: () =>
      import('./pages/manual/manual.module').then((m) => m.ManualPageModule),
  },
  {
    path: 'recuperar',
    loadChildren: () =>
      import('./pages/recuperar/recuperar.module').then(
        (m) => m.RecuperarPageModule
      ),
  },
  {
    path: 'proteccio-dades',
    loadChildren: () =>
      import('./pages/proteccio-dades/proteccio-dades.module').then(
        (m) => m.ProteccioDadesPageModule
      ),
  },
  {
    path: 'crear-producte',
    loadChildren: () => import('./pages/crear-producte/crear-producte.module').then( m => m.CrearProductePageModule)
  },
];

@NgModule({
  imports: [
    RouterModule.forRoot(routes, { preloadingStrategy: PreloadAllModules }),
  ],
  exports: [RouterModule],
})
export class AppRoutingModule {}
