import { Component, OnInit } from '@angular/core';
import { SessioService } from 'src/app/services/sessio.service';
import { NotificacionsService } from 'src/app/services/notificacions.service';
import { ToastController } from '@ionic/angular';

@Component({
  selector: 'app-menu',
  templateUrl: './menu.component.html',
  styleUrls: ['./menu.component.scss'],
})
export class MenuComponent implements OnInit {
  constructor(
    public sessioService: SessioService,
    public notService: NotificacionsService,
    private toastController: ToastController
  ) {}

  ngOnInit() {}

  tancar() {
    this.sessioService.openMenu = false;
    localStorage.removeItem('token');
    localStorage.removeItem('userId');
    this.presentToast('Sessió tancada correctament');
  }

  //Mostra els missatges de resposta en pantalla.

  async presentToast(missatge: any) {
    const toast = await this.toastController.create({
      message: missatge,
      duration: 2000,
      color: 'warning',
    });
    toast.present();
  }
}
