import { Component, Input, OnInit } from '@angular/core';
import { ModalController } from '@ionic/angular';
import { NotificacionsService } from 'src/app/services/notificacions.service';
import { ToastController } from '@ionic/angular';

@Component({
  selector: 'app-modal-notificacions',
  templateUrl: './modal-notificacions.page.html',
  styleUrls: ['./modal-notificacions.page.scss'],
})
export class ModalNotificacionsPage implements OnInit {
  @Input() notificacions: any;

  constructor(
    public modalController: ModalController,
    private notificacionsService: NotificacionsService,
    private toastController: ToastController
  ) {}

  ngOnInit() {
    //console.log(this.notificacions);
  }

  //Funció que permet eliminar les notificacions.
  eliminar(dades: any) {
    //console.log(dades.id);
    const enviarId = { id: dades.id };
    this.notificacionsService.deleteNotificacions(enviarId).subscribe((res) => {
      if (res.status === '1') {
        this.presentToast(res.missatge);
        this.sortir();
      }
    });
  }

  sortir() {
    this.modalController.dismiss({
      dismissed: true,
    });
  }

  //Mostra els missatges de resposta en pantalla.

  async presentToast(missatge: any) {
    const toast = await this.toastController.create({
      message: missatge,
      duration: 2000,
      color: 'warning',
    });
    toast.present();
  }
}
