import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { ResNoticies } from '../interfaces/interfaces';
import { environment } from 'src/environments/environment';

const apiKey = environment.apiKeyMedia;

@Injectable({
  providedIn: 'root',
})
export class NoticiesService {
  constructor(private http: HttpClient) {}

  //Funció que fa la crida a l'API de notícies i retorna els resultats.
  getNoticies() {
    return this.http.get<ResNoticies>(
      //`https://newsapi.org/v2/top-headlines?country=ar&category=science&apiKey=${apiKey}`
      `http://api.mediastack.com/v1/news?access_key=${apiKey}&languages=en&categories=science`
    );
  }
}
