import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class NotificacionsService {
  api = environment.apiConnexio + 'notificacions.php';
  notificacions = '';

  constructor(private http: HttpClient) {}

  //Mètode GET que crida a l'API per mostrar les notificacions.
  getNotificacions(): Observable<any> {
    return this.http.get(this.api);
  }

  //Mètode POST que crida a l'API per marcar com a llegides les notificacions a la base.
  postNotificacions(form: any): Observable<any> {
    //console.log(form);
    return this.http.post(this.api, form);
  }

  //Mètode DELETE que crida a l'API per esborrar les notificacions de la base.
  deleteNotificacions(id: any): Observable<any> {
    console.log(id);
    const options = {
      headers: new HttpHeaders({
        'content-type': 'application/json',
      }),
      body: id,
    };
    return this.http.delete(this.api, options);
  }
}
