import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class RegistreCorreuService {
  api = environment.apiConnexio + 'usuariCorreu.php';

  constructor(private http: HttpClient) {}

  //Funció que crida a l'API amb el codi de validació.

  postValidarCorreu(form: any): Observable<any> {
    return this.http.post(this.api, form);
  }

  //Funció que crida a l'API amb el correu electrònic per crear la validació.

  putEnviarCorreu(form: any): Observable<any> {
    return this.http.put(this.api, form);
  }
}
