import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';

@Injectable({
  providedIn: 'root',
})
export class TemporalService {
  api = environment.apiConnexio + 'temporal.php';

  constructor(private http: HttpClient) {}

  //Mètode GET que crida a l'API per mostrar productes a la base.
  getProductes(): Observable<any> {
    return this.http.get(this.api);
  }

  //Mètode POST que crida a l'API per inserir productes a la base.
  postProductes(form: any): Observable<any> {
    //console.log(form);
    return this.http.post(this.api, form);
  }

  //Mètode DELETE que crida a l'API per esborrar productes de la base.
  deleteProductes(codi: any): Observable<any> {
    //console.log(codi);
    const options = {
      headers: new HttpHeaders({
        'content-type': 'application/json',
      }),
      body: codi,
    };
    return this.http.delete(this.api, options);
  }
}
